#!/usr/bin/python
# coding:utf-8

# nalozimo knjiznice
import lxml.html
import json
import urllib
import time

# naslov, kjer se nahaja program festivala
root = 'http://www.liffe.si/program/abc-seznam/'

# preberimo spletno stran
h = lxml.html.parse(root).getroot()
h.make_links_absolute(root)

# zanimajo nas zapisi v tabeli filmov
# s spodnjim ukazom poiščemo vrstice (tr) znotraj tabele (table),
# ki se nahaja znotraj obrazca (form), katerega atribut "id" je "pluginAppForm"
trs = h.xpath('//form[@id="pluginAppForm"]//table/tr')

# seznam za shranjevanje zapisov
filmi = []

CACHE = 'cached.omdbapi.json'
cache = json.load(open(CACHE))

# sprehodimo se po vseh vrsticah
for num, tr in enumerate(trs):
	# znotraj vrstice tr izberemo polja (td)
	tds = tr.xpath('.//td')
	print num
	
	# iz vsakega polja poberemo besedilo (text())
	teksti = []
	for c in tds:
		teksti = teksti + c.xpath('.//text()')
	
	# ker so v nekaterih vrsticah črte med črkami abecede,
	# je potrebno te odstraniti
	if len(teksti) != 6:
		continue
	
	# locimo drzavo in leto v dve polji
	drzava_leto = teksti[2].rsplit(', ', 1)
	
	print teksti[1]
	# dodajmo še ocene in žanr iz IMDB
	# sestavimo url
	orig_naslov = urllib.quote(unicode(teksti[1]).encode('utf-8'))
	url = 'http://www.omdbapi.com/?t=%s&y=%s' % (orig_naslov, drzava_leto[1])
	
	imdb = cache.get(url)
	hit = True
	if imdb is None:
		hit = False
		# prenesimo url
		imdb_text = urllib.urlopen(url).read()
		
		# nalozimo JSON zapis v program
		imdb = json.loads(imdb_text)
		if imdb.get('Response') == 'True':
			cache[url] = imdb
			json.dump(cache, open(CACHE, 'wb'))
		elif imdb.get('Error') == u'Movie not found!':
			url2 = 'http://www.omdbapi.com/?t=%s&y=%s' % (orig_naslov, drzava_leto[1])
	
	# preberemo oceno
	print imdb
	imdb_ocena = imdb.get('imdbRating', '')
	imdb_ocen = imdb.get('imdbVotes', '')
	if imdb.get('imdbID', ''):
		imdb_url = 'http://www.imdb.com/title/%s' % imdb.get('imdbID', '')
	else:
		imdb_url = ''
	imdb_zanr = imdb.get('Genre', '')
	
	# vkomponiramo nova polja
	teksti = teksti[:2] + drzava_leto + teksti[3:] + [imdb_ocena, imdb_ocen, imdb_zanr, imdb_url]
	
	# izpisimo informacije, ki jih imamo sedaj
	print teksti
	
	# dodajmo informacije o filmu v seznam filmov
	filmi.append(teksti)
	
	if not hit:
		time.sleep(10)
	

# nalozimo modul csv
import csv

# odprimo novo datoteko liffe22.csv, v katero bomo podatke shranili
wr = csv.writer(open('liffe22.csv','w'))

# vpisimo naslove stolpcev
wr.writerow(['Naslov', 'Originalni naslov', 'Drzava', 'Leto', 'Rezija', 'Jezik', 'Kategorija', 'IMDB ocena', 'IMDB ocen', 'IMDB zanr', 'IMDB url'])

# vsak film vpisemo v datoteko
for f in filmi:
	polja = []
	for p in f:
		polja.append(p.encode('utf-8'))
	wr.writerow(polja)
